% This is the main function for preparing the data for sAET
% NOTE:
% The application requires some subfunction from GENFIRE. Please install
% GENFIRE first.


DsetProjs=importdata('prepA.mat');
DsetProjs=DsetProjs(:,:,1:13);

DsetProjs = My_stripzero(DsetProjs(:,:,1:13),[510 510 13]);

AnglesGenfire = importdata( 'anglesA.mat');
%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%% COM
PosModel = importdata('CenterA.mat');

figure;colormap(violetFire)
for i=1:size(DsetProjs,3)
  imagesc(DsetProjs(:,:,i));axis image; hold on;title(sprintf('Image %d',i));
  colorMax1 = fix(max(max(DsetProjs(:,:,i))));caxis([colorMax1*0/12, colorMax1*9/12]); 
%   plot(mean(fitted_Peak_pos2(particleList,i,2),1),mean(fitted_Peak_pos2(particleList,i,1),1),'wo');
  plot(PosModel(1,i,2),PosModel(1,i,1),'wo')
  hold off
  pause
end 
% finalCOM = mean(fitted_Peak_pos2(particleList,:,:),1);
% PeakPos = finalCOM;


PeakPos = PosModel;

%% align different images refer to 0 projection

GEproj = zeros(size(DsetProjs));
dim1 = size(DsetProjs,1);
dim2 = size(DsetProjs,2);

COMrefX = dim1/2+1;
COMrefY = dim2/2+1;

%croping
finalCropX = 60;
finalCropY = 60;
paddingSize = 4;
MaskRange = -finalCropX/2+paddingSize:finalCropX/2-1-paddingSize;

ProjsCropRaw = zeros(finalCropX,finalCropY,size(DsetProjs,3));
ProjsCropFinal = zeros(finalCropX,finalCropY,size(DsetProjs,3));

CenterXFinal = round((size(ProjsCropFinal,1)+1)/2);
CenterYFinal = round((size(ProjsCropFinal,1)+1)/2);

% create mask
OV = 2;
MaskIndDim1 = (MaskRange) + CenterXFinal;
MaskIndDim2 = (MaskRange) + CenterYFinal;
ModelMask = zeros(finalCropX,finalCropY,finalCropX);
ModelMask(MaskIndDim1,MaskIndDim2,CenterYFinal) = 1;
% ModelMask(:,:,CenterYFinal) = mask;

ModelMaskGaussian = zeros(finalCropX,finalCropY,finalCropX);
myfilter = fspecial('gaussian',[3 3], 1);
ModelMaskGaussian(:,:,CenterYFinal) = imfilter(ModelMask(:,:,CenterYFinal), myfilter, 'replicate','same');
clear ModelMask,

ModelK_MaskGaussian = My_FFTN(My_paddzero(ModelMaskGaussian,size(ModelMaskGaussian)*OV));

% MaskStack = zeros(size(ProjsCropFinal));
MaskStackGaussian = zeros(size(ProjsCropFinal));

% using calib angles and INPUT ZXY vectors to GENFIRE
Z = [0 0 1]';
Y = [0 1 0]';
X = [1 0 0]';

%%
mkdir Model60Scan_Refined
cd Model60Scan_Refined

toRemoveList= [];
        
refPJ = 12;

for a = 30*[-4:4]
    for b = 30*[-4:4]

        zeroVector=[a b 0] + [50 10 0]
        vectorsOrigin = scanOriginVector(zeroVector,AnglesGenfire);
        for pj = 1:size(DsetProjs,3) 
            fprintf('Projections %d\n',pj);
            FFD = squeeze(DsetProjs(:,:,pj));
            COMX = PeakPos(1,pj,1)+vectorsOrigin(pj,1);
            COMY = PeakPos(1,pj,2)+vectorsOrigin(pj,2);
            xshift = COMrefY - COMX;
            yshift = COMrefY - COMY;
            GEproj(:,:,pj) = abs(My_FourierShift(FFD,xshift,yshift));

            ProjsCropRaw(:,:,pj) = My_stripzero(GEproj(:,:,pj), [finalCropX,finalCropY]);

            TempMasksG = calculate3Dprojection_interp_general(ModelK_MaskGaussian,AnglesGenfire(pj,1),AnglesGenfire(pj,2),AnglesGenfire(pj,3),Z,Y,X);
            TempMasksG = My_stripzero(TempMasksG, [finalCropX,finalCropY]);
            TempMasksG(TempMasksG>0.9) = 1;
            TempMasksG(TempMasksG<0.17) = 0;

            MaskStackGaussian(:,:,pj) = TempMasksG;

        end
        % gaussian mask normalize

        ProjsCropFinalBGSUB = zeros(size(ProjsCropRaw));
        ProjsCropFinalBGSUBGauss = zeros(size(ProjsCropRaw));

        refFFD = squeeze(ProjsCropRaw(:,:,refPJ));
        refFFDGauss = squeeze(ProjsCropRaw(:,:,refPJ));

        refFFDGauss_2 = (refFFDGauss-min(refFFDGauss(:))).*MaskStackGaussian(:,:,refPJ);
        refFFDGauss_2(refFFDGauss_2<0) = 0;
        refTSDGauss_2 = sum(refFFDGauss_2(:));  %The real TSD of refind slice

        if 1
            figure(13);
            subplot(121);imagesc(refFFD);axis image;
            % subplot(122);plot(locs,pks,'ro',bins*255,h);pause;
            subplot(122);imhistTian(refFFDGauss_2);
            subplot(122);imagesc(refFFDGauss_2);axis image;pause(1);
        end

        ProjsCropFinalBGSUBGauss(:,:,refPJ) = refFFDGauss_2;

        for pj = 1:size(ProjsCropRaw,3)

            FFDGauss = squeeze(ProjsCropRaw(:,:,pj));
            if pj == refPJ
                continue;
            end

            FFDGauss_2 = (FFDGauss-min(FFDGauss(:))).*MaskStackGaussian(:,:,pj);
            FFDGauss_2(FFDGauss_2<0) = 0;
            ratioTSD = sum(FFDGauss_2(:))/refTSDGauss_2;
            FFDGauss_2=FFDGauss_2/ratioTSD;

%             subplot(121);imagesc(FFDGauss);axis image;title(sprintf('%d',pj));        
%             subplot(122);imhistTian(FFDGauss_2);%pause(1);
%             subplot(122);imagesc(FFDGauss_2);axis image;title(sprintf('%d',pj));pause(1)

            ProjsCropFinalBGSUBGauss(:,:,pj) = FFDGauss_2;    
    
        end

        ProjsCropFinalBGSUBGauss(:,:,toRemoveList)=[];

        save(sprintf('ProjsBM3D100_refine%s_a%sb%s_edge0.mat',num2str(finalCropX),num2str(a),num2str(b)),'ProjsCropFinalBGSUBGauss');
        fprintf('SAVED\n');

    end
end

% save MaskNew2DTraceAngle240_edge0.mat MaskStackGaussian

Angles=AnglesGenfire;
Angles(toRemoveList,:)=[];
save('AnglesGenfire.mat','Angles');

support=zeros(finalCropX,finalCropY,finalCropX);
support(:,:,CenterXFinal-16:CenterXFinal+16)=1;
support = My_stripzero(support,[finalCropX-paddingSize*2,finalCropY-paddingSize*2,finalCropX-paddingSize*2]);
support = My_paddzero(support,[finalCropX,finalCropY,finalCropX]);
save(sprintf('support%s_33.mat',num2str(finalCropX)),'support');

supportS = smooth3(support,'gaussian',5,1);
save(sprintf('support%s_33_Gaussian1.mat',num2str(finalCropX)),'supportS');

cd ..
